// Commtty.cpp

#include "stdafx.h"
#include "sercom.h"
#include "scomdlg.h"
#include "commtty.h"

TTYINFO		TTYInfo;
CString		gszPort;
HANDLE		ghThreadExitEvent;
BOOL		gbHexShow = FALSE;

//Ԥ
COMMTIMEOUTS gTimeoutsDefault = { 0x01, 0, 0, 0, 0 };

/////////////////////////////////////////////////////////////////////
// Functions
//ûö˿״̬
BOOL UpdateConnection()
{
    DCB dcb = {0};
    dcb.DCBlength = sizeof(dcb);
    // ȡǰ˿
    if (!GetCommState(COMDEV(TTYInfo), &dcb))
		ErrorReporter("GetCommState");

    // ²ʡУ顢λֹͣλ
    dcb.BaudRate = BAUDRATE(TTYInfo);
    dcb.ByteSize = BYTESIZE(TTYInfo);
    dcb.Parity   = PARITY(TTYInfo);
    dcb.StopBits = STOPBITS(TTYInfo);

	//
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fInX = dcb.fOutX = FALSE;
	dcb.XonChar = ASCII_XON;
	dcb.XoffChar = ASCII_XOFF;
	dcb.XonLim = 100;
	dcb.XoffLim = 100;
	
	dcb.fBinary = TRUE;
	dcb.fParity = TRUE;

    // ״̬
    if (!SetCommState(COMDEV(TTYInfo), &dcb))
	{
		ErrorReporter("SetCommState");
		if (GetCommState(COMDEV(TTYInfo), &dcb))
		{
			BAUDRATE(TTYInfo) = dcb.BaudRate;
			PARITY(TTYInfo) = dcb.Parity;
			BYTESIZE(TTYInfo) = dcb.ByteSize;
			STOPBITS(TTYInfo) = dcb.StopBits;
		}
	}

    // TIMEOUT
    if (!SetCommTimeouts(COMDEV(TTYInfo), &(TIMEOUTSNEW(TTYInfo))))
		ErrorReporter("SetCommTimeouts");

    return TRUE;
}

//д߳
void StartThreads(void)
{
	// ߳
    DWORD dwReaderId;
    READERTHREAD(TTYInfo) = 
            CreateThread( NULL, 
                          0,
                          (LPTHREAD_START_ROUTINE) ReaderProc,
                          (LPVOID)NULL, 
                          0, 
                          &dwReaderId);

    if (READERTHREAD(TTYInfo) == NULL)
        ErrorInComm("CreateThread (Reader)");

    return;
}

//ͨѶ˿
HANDLE SetupCommPort(void)
{
    COMDEV(TTYInfo) = CreateFile(gszPort,
		GENERIC_READ | GENERIC_WRITE,
		0, 
		0, 
		OPEN_EXISTING,
		FILE_FLAG_OVERLAPPED,
		0);
	
	if (COMDEV(TTYInfo) == INVALID_HANDLE_VALUE)
	{
        ErrorReporter("CreateFile");
		return NULL;
	}

	if (!GetCommTimeouts(COMDEV(TTYInfo), &(TIMEOUTSORIG(TTYInfo))))
		ErrorReporter("GetCommTimeouts");

    // ö˿״̬
    UpdateConnection();

    // ö˿ڻС
    SetupComm(COMDEV(TTYInfo), MAX_READ_BUFFER, MAX_WRITE_BUFFER);

	// ʱ
	COMMTIMEOUTS to;
	to.ReadIntervalTimeout = 20;
	to.ReadTotalTimeoutMultiplier = 1;
	to.ReadTotalTimeoutConstant = 50;
	to.WriteTotalTimeoutMultiplier = 1;
	to.WriteTotalTimeoutConstant = 50;
	SetCommTimeouts(COMDEV(TTYInfo), &to);

    // start threads and set initial thread state to not done
    StartThreads();

    // ӱ־
    CONNECTED(TTYInfo) = TRUE;

    return COMDEV(TTYInfo);
}

//رչ߳ǰȴһʱ
DWORD WaitForThreads(DWORD dwTimeout)
{	
    // set thread exit event here
    SetEvent(ghThreadExitEvent);

    DWORD  dwRes = WaitForSingleObject(READERTHREAD(TTYInfo), dwTimeout);
    switch(dwRes)
    {
        case WAIT_OBJECT_0:
            dwRes = WAIT_OBJECT_0;
            break;

        case WAIT_TIMEOUT:
			OutputDebugString("Reader Thread didn't exit.\n\r");
            break;

        default:
            ErrorReporter("WaitForSingleObject (ThreadExit)");
            break;
    }

    // reset thread exit event here
    ResetEvent(ghThreadExitEvent);

    return dwRes;
}

//жͨѶ˿
BOOL BreakDownCommPort(void)
{
    if (!CONNECTED(TTYInfo))
        return FALSE;

    CONNECTED( TTYInfo ) = FALSE;

    // wait for the threads for a small period
    if (WaitForThreads(20000) != WAIT_OBJECT_0)
        ErrorHandler("Error closing port.");


    // ָԭʼTIMEOUT
    if (!SetCommTimeouts(COMDEV(TTYInfo),  &(TIMEOUTSORIG(TTYInfo))))
        ErrorReporter("SetCommTimeouts (Restoration to original)");

    // д
    if (!PurgeComm(COMDEV(TTYInfo), PURGE_TXABORT|PURGE_TXCLEAR|
									PURGE_RXABORT|PURGE_RXCLEAR))
        ErrorReporter("PurgeComm");

    CloseHandle(COMDEV(TTYInfo));
    CloseHandle(READERTHREAD(TTYInfo));

    return TRUE;
}

//ʼTTYInfoṹ
BOOL InitTTYInfo()
{
    COMDEV( TTYInfo )        = NULL;
    CONNECTED( TTYInfo )     = FALSE;

    PORT( TTYInfo )          = 1;
    BAUDRATE( TTYInfo )      = CBR_57600;
    BYTESIZE( TTYInfo )      = 8;
    PARITY( TTYInfo )        = NOPARITY;
    STOPBITS( TTYInfo )      = ONESTOPBIT;

    TIMEOUTSNEW( TTYInfo )   = gTimeoutsDefault;

    DISPLAYERRORS( TTYInfo ) = TRUE;
    SHOWTIMEOUTS( TTYInfo )  = TRUE;

    return TRUE;
}

DWORD ErrorExtender(DWORD, char**);
// Ϊַ
DWORD ErrorExtender(DWORD dwError, char** szBuffer)
{
    DWORD dwRes = 0;

    dwRes = FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ALLOCATE_BUFFER | 80 ,
                          NULL, dwError,
                          MAKELANGID(LANG_CHINESE, SUBLANG_CHINESE_SIMPLIFIED),
                          (LPTSTR) szBuffer, 0, NULL);

    if (dwRes == 0) {
        *szBuffer = (char*)LocalAlloc(LPTR, 1);
        return 1;
    }

    return dwRes;
}

// 󱨸
void ErrorReporter(char* szMessage)
{
    char* szFormat = "Error %d: %s.\n\r%s\r\n";    // format for wsprintf
    char* szExtended;      // error string translated from error code
    char* szFinal;         // final string to report
    DWORD dwExtSize;
    DWORD dwErr;

    dwErr = GetLastError();
    dwExtSize = ErrorExtender(dwErr, &szExtended);
    szFinal = (char*)LocalAlloc(LPTR, strlen(szMessage) + dwExtSize + 30);

	HWND hWnd = AfxGetApp()->GetMainWnd()->m_hWnd;

    if (szFinal == NULL)
        MessageBox(hWnd, "Cannot properly report error.", "Fatal Error", MB_OK);
    else {	
        wsprintf(szFinal, szFormat, dwErr, szMessage, szExtended);

        OutputDebugString(szFinal);

        if (DISPLAYERRORS(TTYInfo))
            MessageBox(hWnd, szFinal, NULL, MB_OK);

        LocalFree(szFinal);
    }

    LocalFree(szExtended);

    return;
}

// ͨѶ˿ڴǰ
void ErrorHandler(char* szMessage)
{	
    ErrorReporter(szMessage);
    ExitProcess(0);
}

// ͨŹд
void ErrorInComm(char* szMessage)
{
    ErrorReporter(szMessage);
    BreakDownCommPort();
    ExitProcess(0);
}

//ͨѶ˿ڶ״̬ѯ߳
DWORD WINAPI ReaderProc(LPVOID lpV)
{
	CRichEditCtrl &rerecv = ((CSerComDlg*)(AfxGetApp()->GetMainWnd()))->m_rerecv;
	OVERLAPPED osReader = {0};

    // create overlapped structure for read events
    osReader.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
    if (osReader.hEvent == NULL)
        ErrorInComm("CreateEvent (Reader Event)");

    // Detect read events (from ReadFile)
    HANDLE hArray[2];
    hArray[0] = osReader.hEvent;
    hArray[1] = ghThreadExitEvent;

	BOOL fDone = FALSE;
    BOOL fWaitingOnRead = FALSE;
    char lpBuf[AMOUNT_TO_READ];
	DWORD dwRead;
    while (!fDone)
	{
        // if no read is outstanding, then issue another one
        if (!fWaitingOnRead)
		{
            if (!ReadFile(COMDEV(TTYInfo), lpBuf, AMOUNT_TO_READ, &dwRead, &osReader))
			{
                if (GetLastError() != ERROR_IO_PENDING)	  // read not delayed?
                    ErrorInComm("ReadFile in ReaderAndStatusProc");

                fWaitingOnRead = TRUE;
            }
            else
			{    // read completed immediately
				if (dwRead)
				{
					CString strrecv;
					if (!gbHexShow)
					{
						strrecv= lpBuf;
						strrecv = strrecv.Left(dwRead);
					}
					else
					{
						for (DWORD i=0; i<dwRead; i++)
						{
							CString sb;
							sb.Format(_T("%02X "), (BYTE)lpBuf[i]);
							strrecv += sb;
						}
					}
					rerecv.SetSel(rerecv.GetTextLength(), rerecv.GetTextLength());
					rerecv.ReplaceSel(strrecv);
				}
            }
        }

        // wait for pending operations to complete
        if (fWaitingOnRead)
		{
            DWORD dwRes = WaitForMultipleObjects(2, hArray, FALSE, READ_CHECK_TIMEOUT);
            switch(dwRes)
            {
                // read completed
                case WAIT_OBJECT_0:
                    if (!GetOverlappedResult(COMDEV(TTYInfo), &osReader, &dwRead, FALSE))
					{
                        if (GetLastError() == ERROR_OPERATION_ABORTED)
                            ErrorReporter("Read aborted\r\n");
                        else
                            ErrorInComm("GetOverlappedResult (in Reader)");
                    }
                    else
					{      // read completed successfully
						if (dwRead)
						{
							CString strrecv;
							if (!gbHexShow)
							{
								strrecv= lpBuf;
								strrecv = strrecv.Left(dwRead);
							}
							else
							{
								for (DWORD i=0; i<dwRead; i++)
								{
									CString sb;
									sb.Format(_T("%02X "), (BYTE)lpBuf[i]);
									strrecv += sb;
								}
							}
							rerecv.SetSel(rerecv.GetTextLength(), rerecv.GetTextLength());
							rerecv.ReplaceSel(strrecv);
						}
                    }

                    fWaitingOnRead = FALSE;
                    break;

				// thread exit event
                case WAIT_OBJECT_0 + 1:
                    fDone = TRUE;
                    break;

                case WAIT_TIMEOUT:
                    break;                       

                default:
                    ErrorReporter("WaitForMultipleObjects(Reader handles)");
                    break;
            }
        }
    }

    // close event handle
    CloseHandle(osReader.hEvent);

	return 1;
}

//ݷ
void WriterGeneric(const char* lpBuf, DWORD dwToWrite)
{
    OVERLAPPED osWrite = {0};
    // create this writes overlapped structure hEvent
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
    if (osWrite.hEvent == NULL)
        ErrorInComm("CreateEvent (overlapped write hEvent)");

    HANDLE hArray[2];
    hArray[0] = osWrite.hEvent;
    hArray[1] = ghThreadExitEvent;
    
    // issue write
    DWORD dwWritten;
    if (!WriteFile(COMDEV(TTYInfo), lpBuf, dwToWrite, &dwWritten, &osWrite))
	{
        if (GetLastError() == ERROR_IO_PENDING)
		{
            // write is delayed
            DWORD dwRes = WaitForMultipleObjects(2, hArray, FALSE, INFINITE);
            switch(dwRes)
            {
                // write event set
                case WAIT_OBJECT_0:
					SetLastError(ERROR_SUCCESS);
					if (!GetOverlappedResult(COMDEV(TTYInfo), &osWrite, &dwWritten, FALSE))
					{
						if (GetLastError() == ERROR_OPERATION_ABORTED)
							ErrorReporter("Write aborted\r\n");
						else
							ErrorInComm("GetOverlappedResult(in Writer)");
					}
					
					if (dwWritten != dwToWrite)
					{
						if ((GetLastError() == ERROR_SUCCESS) && SHOWTIMEOUTS(TTYInfo))
							ErrorReporter("Write timed out. (overlapped)\r\n");
						else
							ErrorReporter("Error writing data to port (overlapped)");
					}
					break;

                // thread exit event set
                case WAIT_OBJECT_0 + 1:
					break;

                // wait timed out
                case WAIT_TIMEOUT:
					ErrorReporter("Wait Timeout in WriterGeneric.\r\n");
					break;

                case WAIT_FAILED:
                default:
					ErrorInComm("WaitForMultipleObjects (WriterGeneric)");
					break;
			}
        }
        else    
            // writefile failed, but it isn't delayed
            ErrorInComm("WriteFile (in Writer)");
	}
    else
	{
		// writefile returned immediately
		if (dwWritten != dwToWrite)
			ErrorReporter("Write timed out. (immediate)\r\n");
	}

    CloseHandle(osWrite.hEvent);
    
    return;
}
